//#############################################################################
//# Huge arrays and pointers for Microsoft Windows                            #
//#############################################################################
// Author: Paul Andre LeBlanc   CIS 71043,1643

#ifndef __HUGECLASS_H__
#define __HUGECLASS_H__

#include <stddef.h>
#include <windows.h>

extern LPVOID __HugeAdd(LPVOID, LONG, WORD);
extern LPVOID __HugeAlloc(LONG, WORD);
extern void __HugeFree(LPVOID);

//*****************************************************************************
//* template class HugePointer                                                *
//*****************************************************************************

template <class T>
class HugePointer
{
  protected :
    LPVOID address;
  public:
    HugePointer(LPVOID p = NULL) : address(p) {}
    operator T FAR *()	       { return (T FAR *) address; }
    T FAR *operator +(LONG n)  { return (T FAR *) __HugeAdd(address, n, sizeof(T)); }
    T FAR *operator -(LONG n)  { return *this + -n; }
    T FAR *operator ++(void)   { return *this = *this + 1; }
    T FAR *operator ++(int)    { T FAR *a = *this; *this = *this + 1; return a; }
    T FAR *operator --(void)   { return *this = *this - 1; }
    T FAR *operator --(int)    { T FAR *a = *this; *this = *this - 1; return a; }
    T FAR *operator +=(LONG n) { return *this = *this + n; } 
    T FAR *operator -=(LONG n) { return *this = *this - n; }
    T FAR *operator ->()       { return (T FAR *) address; }
    T FAR &operator [](LONG n) { return *((T FAR *) (*this + n)); }
};

//*****************************************************************************
//* template class HugeArray                                                  *
//*****************************************************************************

template <class T, long elements>
class HugeArray : public HugePointer<class T>
{
  public:
    HugeArray(void) : HugePointer<T>(__HugeAlloc(elements, sizeof(T))) {}
    ~HugeArray() { __HugeFree(address); }
};

#endif //__HUGECLASS_H__
